using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Authenticaion.Commands
    .RenewAccessTokenWithCookie;

public class RenewAccessTokenWithCookieCommandHandler :
    IRequestHandler<RenewAccessTokenWithCookieCommand, TokensModel>
{
    private readonly AuthenticationService _authenticationService;
    private readonly SessionUserService _sessionUserService;

    public RenewAccessTokenWithCookieCommandHandler(
        AuthenticationService authenticationService,
        SessionUserService sessionUserService)
    {
        _authenticationService = authenticationService;
        _sessionUserService = sessionUserService;
    }

    public async Task<TokensModel> Handle(
        RenewAccessTokenWithCookieCommand request,
        CancellationToken cancellationToken)
    {
        return await _authenticationService.RenewAccessTokenAsync(
            _sessionUserService.RefreshToken, cancellationToken);
    }
}
