using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Authenticaion.Queries.Login;

public class LoginQueryHandler : IRequestHandler<LoginQuery, TokensModel>
{
    private readonly AuthenticationService _authenticationService;

    public LoginQueryHandler(AuthenticationService authenticationService)
    {
        _authenticationService = authenticationService;
    }

    public async Task<TokensModel> Handle(
        LoginQuery request, CancellationToken cancellationToken)
    {
        return await _authenticationService.LoginAsync(
            request.Email, request.Password, cancellationToken);
    }
}
