using cuqmbr.TravelGuide.Application.Common.Interfaces.Persistence.Repositories;

namespace cuqmbr.TravelGuide.Application.Common.Interfaces.Persistence;

public interface UnitOfWork : IDisposable
{
    CountryRepository CountryRepository { get; }

    RegionRepository RegionRepository { get; }

    CityRepository CityRepository { get; }

    AddressRepository AddressRepository { get; }

    RouteRepository RouteRepository { get; }

    int Save();

    Task<int> SaveAsync(CancellationToken cancellationToken);
}
