using cuqmbr.TravelGuide.Application.Common.Models;
using cuqmbr.TravelGuide.Domain.Enums;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Routes.Queries.GetRoutesPage;

public record GetRoutesPageQuery : IRequest<PaginatedList<RouteDto>>
{
    public int PageNumber { get; set; } = 1;

    public int PageSize { get; set; } = 10;

    public string Search { get; set; } = String.Empty;

    public string Sort { get; set; } = String.Empty;

    public VehicleType? VehicleType { get; set; }
}
