namespace cuqmbr.TravelGuide.Identity.Models;

public class RefreshToken
{
    public int Id { get; set; }

    public string Value { get; set; } = null!;

    public DateTimeOffset CreationTimestamp { get; set; }

    public DateTimeOffset ExpirationTimestamp { get; set; }

    public DateTimeOffset? RevokationTimestamp { get; set; }

    public bool IsExpired => DateTimeOffset.UtcNow >= ExpirationTimestamp;

    public bool IsActive => RevokationTimestamp is null && !IsExpired;

    public int IdentityUserId { get; set; }

    public IdentityUser IdentityUser { get; set; }
}

