using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.DependencyInjection;

namespace cuqmbr.TravelGuide.Identity.Persistence.PostgreSql;

public static class PostgreSqlInitializer
{
    public static void Initialize(IServiceProvider serviceProvider)
    {
        using var dbContext = serviceProvider
            .GetService<PostgreSqlIdentityDbContext>();

        var totalMigrationsCount = 
            dbContext.Database.GetMigrations().Count();
        var appliedMigrationCount = 
            dbContext.Database.GetAppliedMigrations().Count();

        if (totalMigrationsCount - appliedMigrationCount > 0)
        {
            dbContext.Database.Migrate();
        }

        if (appliedMigrationCount == 0)
        {
            IdentitySeeder.Seed(serviceProvider);
        }
    }
}
