﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using cuqmbr.TravelGuide.Persistence.PostgreSql;

#nullable disable

namespace Persistence.PostgreSql.Migrations
{
    [DbContext(typeof(PostgreSqlDbContext))]
    [Migration("20250430180231_Add_Countries_Regions_Cities_Addresses")]
    partial class Add_Countries_Regions_Cities_Addresses
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasDefaultSchema("application")
                .HasAnnotation("ProductVersion", "9.0.4")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.HasSequence("addresses_id_sequence");

            modelBuilder.HasSequence("cities_id_sequence");

            modelBuilder.HasSequence("countries_id_sequence");

            modelBuilder.HasSequence("regions_id_sequence");

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Address", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.addresses_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "addresses_id_sequence");

                    b.Property<long>("CityId")
                        .HasColumnType("bigint")
                        .HasColumnName("city_id");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<double>("Latitude")
                        .HasColumnType("double precision");

                    b.Property<double>("Longitude")
                        .HasColumnType("double precision");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(128)")
                        .HasColumnName("name");

                    b.Property<string>("VehicleType")
                        .IsRequired()
                        .HasColumnType("varchar(16)")
                        .HasColumnName("vehicle_type");

                    b.HasKey("Id")
                        .HasName("pk_addresses");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_addresses_Guid");

                    b.HasIndex("CityId")
                        .HasDatabaseName("ix_addresses_city_id");

                    b.HasIndex("Guid")
                        .IsUnique()
                        .HasDatabaseName("ix_addresses_uuid");

                    b.HasIndex("Id")
                        .IsUnique()
                        .HasDatabaseName("ix_addresses_id");

                    b.ToTable("addresses", "application", t =>
                        {
                            t.HasCheckConstraint("ck_addresses_vehicle_type", "vehicle_type IN ('bus', 'train', 'aircraft')");
                        });
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.City", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.cities_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "cities_id_sequence");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.Property<long>("RegionId")
                        .HasColumnType("bigint")
                        .HasColumnName("region_id");

                    b.HasKey("Id")
                        .HasName("pk_cities");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_cities_Guid");

                    b.HasIndex("Guid")
                        .IsUnique()
                        .HasDatabaseName("ix_cities_uuid");

                    b.HasIndex("Id")
                        .IsUnique()
                        .HasDatabaseName("ix_cities_id");

                    b.HasIndex("RegionId")
                        .HasDatabaseName("ix_cities_region_id");

                    b.ToTable("cities", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Country", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.countries_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "countries_id_sequence");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.HasKey("Id")
                        .HasName("pk_countries");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_countries_Guid");

                    b.HasIndex("Guid")
                        .IsUnique()
                        .HasDatabaseName("ix_countries_uuid");

                    b.HasIndex("Id")
                        .IsUnique()
                        .HasDatabaseName("ix_countries_id");

                    b.ToTable("countries", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Region", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.regions_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "regions_id_sequence");

                    b.Property<long>("CountryId")
                        .HasColumnType("bigint")
                        .HasColumnName("country_id");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.HasKey("Id")
                        .HasName("pk_regions");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_regions_Guid");

                    b.HasIndex("CountryId")
                        .HasDatabaseName("ix_regions_country_id");

                    b.HasIndex("Guid")
                        .IsUnique()
                        .HasDatabaseName("ix_regions_uuid");

                    b.HasIndex("Id")
                        .IsUnique()
                        .HasDatabaseName("ix_regions_id");

                    b.ToTable("regions", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Address", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.City", "City")
                        .WithMany("Addresses")
                        .HasForeignKey("CityId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_addresses_city_id");

                    b.Navigation("City");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.City", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Region", "Region")
                        .WithMany("Cities")
                        .HasForeignKey("RegionId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_cities_region_id");

                    b.Navigation("Region");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Region", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Country", "Country")
                        .WithMany("Regions")
                        .HasForeignKey("CountryId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_regions_country_id");

                    b.Navigation("Country");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.City", b =>
                {
                    b.Navigation("Addresses");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Country", b =>
                {
                    b.Navigation("Regions");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Region", b =>
                {
                    b.Navigation("Cities");
                });
#pragma warning restore 612, 618
        }
    }
}
